<template>
  <transition name="modal-fade">
    <div class="modal-backdrop">
      <div
        class="modal"
        role="dialog"
        aria-labelledby="modalTitle"
        aria-describedby="modalDescription"
      >
        <v-container>
          <v-select
            v-model="offer.category"
            :items="categories"
            label="Category"
            outlined
          ></v-select>
          <v-text-field
            v-model="offer.title"
            outlined
            label="Title"
            clearable
          ></v-text-field>
          <v-textarea
            v-model="offer.description"
            outlined
            label="Description"
            clearable
            auto-grow
          ></v-textarea>
          <v-text-field
            v-model="location"
            outlined
            label="Location"
          ></v-text-field>
          <v-dialog
            ref="dialog_date"
            v-model="modal_date"
            :return-value.sync="date"
            width="290px"
            persistent
          >
            <template v-slot:activator="{ on, attrs }">
              <v-text-field
                v-model="date"
                label="Date"
                readonly
                outlined
                v-bind="attrs"
                v-on="on"
              ></v-text-field>
            </template>
            <v-date-picker v-model="date" scrollable outlined>
              <v-btn text color="primary" @click="modal_date = false"
                >Cancel</v-btn
              >
              <v-btn text color="primary" @click="$refs.dialog_date.save(date)"
                >OK</v-btn
              >
            </v-date-picker>
          </v-dialog>
          <v-dialog
            ref="dialog_time"
            v-model="modal_time"
            :return-value.sync="time"
            persistent
            width="290px"
          >
            <template v-slot:activator="{ on, attrs }">
              <v-text-field
                v-model="time"
                label="Time"
                readonly
                outlined
                v-bind="attrs"
                v-on="on"
              ></v-text-field>
            </template>
            <v-time-picker
              v-if="modal_time"
              v-model="time"
              format="24hr"
              scrollable
            >
              <v-btn text color="primary" @click="modal_time = false"
                >Cancel</v-btn
              >
              <v-btn text color="primary" @click="$refs.dialog_time.save(time)"
                >OK</v-btn
              >
            </v-time-picker>
          </v-dialog>
          <v-btn outlined @click="create">Post Offer</v-btn>
          <br />
          <v-btn outlined @click="close">Close</v-btn>
          <span v-if="error" class="error">{{ error }}</span>
          <span v-if="success" class="success">{{ success }}</span>
        </v-container>
      </div>
    </div>
  </transition>
</template>

<script>
import OffersService from '@/services/OffersService'

export default {
  data() {
    return {
      categories: [
        { text: 'mowing', value: 'mowing' },
        { text: 'shopping', value: 'shopping' },
        { text: 'others', value: 'others' }
      ],
      offer: {
        category: null,
        title: null,
        user_id: this.$store.state.store.user.user_id,
        description: null,
        start_date: '',
        location: ''
      },
      date: null,
      time: null,
      location: null,
      modal_date: false,
      modal_time: false,
      error: null,
      success: null
    }
  },
  methods: {
    async create() {
      this.error = null
      this.offer.start_date = `${this.date} ${this.time}`
      this.offer.location = `{'type':'Point','coordinates':[${this.location}]}`
      const areAllFieldsFilledIn = Object.keys(this.offer).every(
        (key) => !!this.offer[key]
      )
      if (!areAllFieldsFilledIn) {
        this.error = 'Please fill in all the fields.'
        return
      }
      try {
        await OffersService.post(this.offer)
        this.success = 'Offer posted!'
      } catch (err) {
        this.error = err
      }
      this.$emit('changeStatus', false)
    },
    close() {
      this.$emit('changeStatus', false)
    }
  }
}
</script>

<style scoped>
.modal-backdrop {
  position: fixed;
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  background-color: rgba(0, 0, 0, 0.25);
  display: flex;
  justify-content: center;
  align-items: center;
}

.modal {
  position: absolute;
  left: calc(25vw + (var(--width-sidebar) / 2));
  height: 75vh;
  width: 50vw;
  box-shadow: 2px 2px 20px 1px;
  overflow: auto;
  display: flex;
  flex-direction: column;
  border-radius: var(--border-radius);
  color: var(--text-primary);
  background: var(--bg-primary);
}

.modal-fade-enter,
.modal-fade-leave-active {
  opacity: 0;
}

.modal-fade-enter-active,
.modal-fade-leave-active {
  transition: opacity 0.5s ease;
}
</style>
